// *************************************************************
//   Created with BCX -- The BASIC To C Translator (ver 3.00)
//      BCX (c) 1999, 2000, 2001, 2002 by Kevin Diggins
// *************************************************************

#include <windows.h>

int     _stdcall (*Gradientfill) (HDC, PTRIVERTEX, int , PGRADIENT_RECT, int , int );

void Draw_Gradient(HDC hdc, int x, int y, int w, int h, int r, int g, int b)
{
	TRIVERTEX  Vert[2];
	GRADIENT_RECT  Rect;
	// ******************************************************
	Vert[0].x=0;
	Vert[0].y=0;
	Vert[0].Red=65535-(65535-(r*256));
	Vert[0].Green=65535-(65535-(g*256));
	Vert[0].Blue=65535-(65535-(b*256));
	Vert[0].Alpha=0;
	// ******************************************************
	Vert[1].x=w;
	Vert[1].y=h/2;
	Vert[1].Red=65535-(65535-(255*256));
	Vert[1].Green=65535-(65535-(255*256));
	Vert[1].Blue=65535-(65535-(255*256));
	Vert[1].Alpha=0;
	// ******************************************************
	Rect.UpperLeft=0;
	Rect.LowerRight=1;
	// ******************************************************
	Gradientfill(hdc,Vert,2,&Rect,1,GRADIENT_FILL_RECT_V);
	// ******************************************************
	Vert[0].x=0;
	Vert[0].y=h/2;
	Vert[0].Red=65535-(65535-(255*256));
	Vert[0].Green=65535-(65535-(255*256));
	Vert[0].Blue=65535-(65535-(255*256));
	Vert[0].Alpha=0;
	// ******************************************************
	Vert[1].x=w;
	Vert[1].y=h;
	Vert[1].Red=65535-(65535-(r*256));
	Vert[1].Green=65535-(65535-(g*256));
	Vert[1].Blue=65535-(65535-(b*256));
	Vert[1].Alpha=0;
	// ******************************************************
	Rect.UpperLeft=0;
	Rect.LowerRight=1;
	// ******************************************************
	Gradientfill(hdc,Vert,2,&Rect,1,GRADIENT_FILL_RECT_V);
}

int IsMouseOver (HWND hWnd)
{
	RECT  Rect;
	POINT  Pt;
	GetWindowRect(hWnd,&Rect);
	GetCursorPos(&Pt);
	return PtInRect(&Rect,Pt);
}

LRESULT CALLBACK NiceButt(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	static int ButtDown;
	static  HWND  Captured;
	while(1){
		// **************************
		if(Msg==WM_CREATE){
			// **************************
			HRGN  Region;
			RECT  Rct;
			int x;
			int y;
			int w;
			int h;
			ButtDown=FALSE;
			GetClientRect(hWnd,&Rct);
			x=Rct.left;
			y=Rct.top;
			w=Rct.right-Rct.left;
			h=Rct.bottom-Rct.top;
			Region=CreateRoundRectRgn(0,0,w,h,h*0.90,h*0.90);
			SetWindowRgn(hWnd,Region,TRUE);
			InvalidateRect(hWnd,0,0);
			return 0;
			//  *******************
			break;
		}
		if(Msg==WM_PAINT){
			//  *******************
			HDC  hDC;
			PAINTSTRUCT  ps;
			HPEN  hPen;
			HBRUSH  hBrush;
			HBRUSH  hOldBrush;
			RECT  Rct;
			SIZE  Size;
			char T[2048];
			int i, XCtr, YCtr, x, y, w, h, r, g, b;
			//  *******************
			GetClientRect(hWnd,&Rct);
			x=Rct.left;
			y=Rct.top;
			w=Rct.right-Rct.left;
			h=Rct.bottom-Rct.top;
			XCtr=(Rct.left+Rct.right)/2;
			YCtr=(Rct.top+Rct.bottom)/2;
			GetWindowText(hWnd,T,255);
			// **********************************
			//         Draw our control
			// **********************************
			hDC=BeginPaint(hWnd,&ps);
			GetTextExtentPoint32(hDC,T,strlen(T),&Size);
			r=30;
			g=90;
			b=90;
			Draw_Gradient(hDC,x,y,w,h,r,g,b);
			SetBkMode(hDC,TRANSPARENT);
			if(ButtDown){
				SetTextColor(hDC,RGB(255,0,0));
				TextOut(hDC,XCtr-(Size.cx/2)+1,YCtr-(Size.cy/2)+1,T,strlen(T));
			}else{
				SetTextColor(hDC,RGB(0,0,255));
				TextOut(hDC,XCtr-Size.cx/2,YCtr-Size.cy/2,T,strlen(T));
			}
			EndPaint(hWnd,&ps);
			return 0;
			// ******************************
		break;
		}
		if(Msg==WM_LBUTTONUP){
			// ******************************
			if(hWnd==Captured){
				HWND  hParent;
				ReleaseCapture();
				ButtDown=FALSE;
				InvalidateRect(hWnd,0,0);
				hParent=GetParent(hWnd);
				SendMessage(hParent, (UINT)WM_COMMAND,(WPARAM) MAKELONG(GetWindowLong(hWnd,(LPARAM)GWL_ID),BN_CLICKED),(long)hWnd);
			}
			return 0;
			// ******************************
			break;
		}
		if(Msg==WM_LBUTTONDOWN){
			// ******************************
			SetCapture(hWnd);
			Captured=hWnd;
			ButtDown=TRUE;
			SetFocus(hWnd);
			InvalidateRect(hWnd,0,0);
			return 0;
			// ******************************
			break;
		}
		if(Msg==WM_MOUSEMOVE){
			// ******************************
			if(ButtDown){
				if(IsMouseOver(hWnd)){
					ButtDown=TRUE;
					InvalidateRect(hWnd,0,0);
				}else{
					ReleaseCapture();
					ButtDown=FALSE;
					InvalidateRect(hWnd,0,0);
				}
			}
			return 0;
			// ******************************
			break;
		}
		if(Msg==WM_MOVING){
			// ******************************
			ReleaseCapture();
			ButtDown=FALSE;
			InvalidateRect(hWnd,0,0);
			return 0;
			// ******************************
			break;
		}
		if(Msg==WM_SIZE){
			// ******************************
			ReleaseCapture();
			ButtDown=FALSE;
			InvalidateRect(hWnd,0,0);
			return 0;
		}
		break;
	}
	return DefWindowProc(hWnd,Msg,wParam,lParam);
}

int Register_NiceButt (void)
{
	// **********[ DLL Declarations ]**********
	Gradientfill = GetProcAddress(LoadLibrary("MSIMG32.DLL"),"GradientFill");
	if (Gradientfill == NULL)
		return FALSE;

	static  WNDCLASSEX  wc;
	memset(&wc,0,sizeof(wc));
	static char szClassName[2048];
	memset(&szClassName,0,sizeof(szClassName));
	strcpy(szClassName,"NiceButt");
	wc.cbSize=sizeof(wc);
	wc.style=CS_HREDRAW|CS_VREDRAW|CS_GLOBALCLASS;
	wc.hInstance=GetModuleHandle(0);
	wc.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
	wc.lpszClassName=szClassName;
	wc.lpfnWndProc=NiceButt;
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hIcon=0;
	wc.hCursor=0;
	wc.lpszMenuName=0;
	wc.hIconSm=0;
	return RegisterClassEx(&wc);
}

